        SPH         equ 0x3E
        SPL         equ 0x3D
        PORTA       equ 0x02
        DDRA        equ 0x01
        RAMEND      equ 0xBF

        rjmp        _start

        ; functia delay primeste in R17 valoarea pana la care
        ; trebuie sa itereze
_delay: dec         R17
        brne        _delay          ; flagul de zero este setat direct de "dec"
        ret

_dash:  sbi         PORTA, 0        ; aprindem LED-ul
        ldi         R17, 0xFF       ; asteptam mult
        rcall       _delay
        cbi         PORTA, 0        ; stingem LED-ul
        ldi         R17, 0x3F       ; inca un delay pentru spatiere
        rjmp        _delay          ; rcall urmat de ret au fost optimizate cu "rjmp"

_dot:   sbi         PORTA, 0        ; aprindem LED-ul
        ldi         R17, 0x3F       ; asteptam putin
        rcall       _delay
        cbi         PORTA, 0        ; stingem LED-ul
        ldi         R17, 0x3F       ; inca un delay pentru spatiere
        rjmp        _delay          ; rcall urmat de ret au fost optimizate cu "rjmp"

_start: ldi         R16, 0
        out         SPH, R16
        ldi         R16, RAMEND
        out         SPL, R16
        ldi         R16, 0xFF
        out         DDRA, R16

_loop:  rcall       _dash
        rcall       _dash
        rcall       _dot
        rjmp        _loop
